<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>print() for C++20: include/print_list.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">print() for C++20
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">print_list.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;<a class="el" href="print__options_8h_source.html">print_options.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="print__concepts_8h_source.html">print_concepts.h</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for print_list.h:</div>
<div class="dyncontent">
<div class="center"><img src="print__list_8h__incl.png" border="0" usemap="#include_2print__list_8h" alt=""/></div>
<map name="include_2print__list_8h" id="include_2print__list_8h">
<area shape="rect" title=" " alt="" coords="205,5,347,32"/>
<area shape="rect" href="print__options_8h.html" title=" " alt="" coords="330,80,449,107"/>
<area shape="rect" href="print__concepts_8h.html" title=" " alt="" coords="35,155,165,181"/>
<area shape="rect" title=" " alt="" coords="424,229,483,256"/>
<area shape="rect" title=" " alt="" coords="593,155,669,181"/>
<area shape="rect" title=" " alt="" coords="189,155,264,181"/>
<area shape="rect" title=" " alt="" coords="288,155,365,181"/>
<area shape="rect" href="terminalcolors_8h.html" title=" " alt="" coords="389,155,517,181"/>
<area shape="rect" title=" " alt="" coords="272,229,352,256"/>
<area shape="rect" title=" " alt="" coords="5,229,85,256"/>
<area shape="rect" title=" " alt="" coords="109,229,200,256"/>
</map>
</div>
</div><div class="textblock"><div class="dynheader">
This graph shows which files directly or indirectly include this file:</div>
<div class="dyncontent">
<div class="center"><img src="print__list_8h__dep__incl.png" border="0" usemap="#include_2print__list_8hdep" alt=""/></div>
<map name="include_2print__list_8hdep" id="include_2print__list_8hdep">
<area shape="rect" title=" " alt="" coords="123,5,266,32"/>
<area shape="rect" href="print_8h.html" title=" " alt="" coords="137,80,252,107"/>
<area shape="rect" href="print__ostream_8h.html" title=" " alt="" coords="5,155,181,181"/>
<area shape="rect" href="print__shortcuts_8h.html" title=" " alt="" coords="206,155,389,181"/>
</map>
</div>
</div>
<p><a href="print__list_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:afe9466890a34c5498386a55281bf30a7"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:afe9466890a34c5498386a55281bf30a7"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a> (std::ostream &amp;out, const PrintOptions &amp;options, const T &amp;t)</td></tr>
<tr class="memdesc:afe9466890a34c5498386a55281bf30a7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints a single object. Default for objects that are not lists ("atoms").  <a href="print_8h.html#afe9466890a34c5498386a55281bf30a7">More...</a><br /></td></tr>
<tr class="separator:afe9466890a34c5498386a55281bf30a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9e9ae4f30c9bde484e0c197b90e39e46"><td class="memTemplParams" colspan="2">template&lt;concepts::PrintablePair P&gt; </td></tr>
<tr class="memitem:a9e9ae4f30c9bde484e0c197b90e39e46"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__list_8h.html#a9e9ae4f30c9bde484e0c197b90e39e46">print_pair</a> (std::ostream &amp;out, const P &amp;pair, const PrintOptions &amp;options)</td></tr>
<tr class="memdesc:a9e9ae4f30c9bde484e0c197b90e39e46"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints a pair.  <a href="print__list_8h.html#a9e9ae4f30c9bde484e0c197b90e39e46">More...</a><br /></td></tr>
<tr class="separator:a9e9ae4f30c9bde484e0c197b90e39e46"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aecd33a9a08711f90f308fc69f05aa827"><td class="memTemplParams" colspan="2">template&lt;concepts::PrintableList L&gt; </td></tr>
<tr class="memitem:aecd33a9a08711f90f308fc69f05aa827"><td class="memTemplItemLeft" align="right" valign="top">requires concepts::HasLastElement&lt; L &gt; void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__list_8h.html#aecd33a9a08711f90f308fc69f05aa827">print_list</a> (std::ostream &amp;out, const L &amp;list, const PrintOptions &amp;options={})</td></tr>
<tr class="memdesc:aecd33a9a08711f90f308fc69f05aa827"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints an ordered list.  <a href="print__list_8h.html#aecd33a9a08711f90f308fc69f05aa827">More...</a><br /></td></tr>
<tr class="separator:aecd33a9a08711f90f308fc69f05aa827"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ba3a7765fb2dec731f3722c4cb6ee5b"><td class="memTemplParams" colspan="2">template&lt;concepts::PrintableList L&gt; </td></tr>
<tr class="memitem:a3ba3a7765fb2dec731f3722c4cb6ee5b"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__list_8h.html#a3ba3a7765fb2dec731f3722c4cb6ee5b">print_list</a> (std::ostream &amp;out, const L &amp;list, const PrintOptions &amp;options={})</td></tr>
<tr class="memdesc:a3ba3a7765fb2dec731f3722c4cb6ee5b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints an unordered list.  <a href="print__list_8h.html#a3ba3a7765fb2dec731f3722c4cb6ee5b">More...</a><br /></td></tr>
<tr class="separator:a3ba3a7765fb2dec731f3722c4cb6ee5b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:adc7f764bf8b8bbba1e7c57153ac51413"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:adc7f764bf8b8bbba1e7c57153ac51413"><td class="memTemplItemLeft" align="right" valign="top">concept&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__list_8h.html#adc7f764bf8b8bbba1e7c57153ac51413">PrintableListNoString</a></td></tr>
<tr class="memdesc:adc7f764bf8b8bbba1e7c57153ac51413"><td class="mdescLeft">&#160;</td><td class="mdescRight">A list that is not a string or unicode string.  <a href="print__list_8h.html#adc7f764bf8b8bbba1e7c57153ac51413">More...</a><br /></td></tr>
<tr class="separator:adc7f764bf8b8bbba1e7c57153ac51413"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Defines functions that print lists. </p>
</div><h2 class="groupheader">Function Documentation</h2>
<a id="afe9466890a34c5498386a55281bf30a7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afe9466890a34c5498386a55281bf30a7">&#9670;&nbsp;</a></span>print_element()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void print_element </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> &amp;&#160;</td>
          <td class="paramname"><em>options</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>t</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prints a single object. Default for objects that are not lists ("atoms"). </p>
<p>Prints a single object that is a list.</p>
<p>Prints a single object that is a pair.</p>
<p>Lists are all iterable objects, except strings. </p>

</div>
</div>
<a id="aecd33a9a08711f90f308fc69f05aa827"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aecd33a9a08711f90f308fc69f05aa827">&#9670;&nbsp;</a></span>print_list() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">requires concepts::HasLastElement&lt;L&gt; void cpp20print::printing::detail::print_list </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const L &amp;&#160;</td>
          <td class="paramname"><em>list</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> &amp;&#160;</td>
          <td class="paramname"><em>options</em> = <code>{}</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Prints an ordered list. </p>
<p>(Will be truncated as [1, 2, 3, ..., 100]). Individual elements will be printed as if directly passed to print. </p>

</div>
</div>
<a id="a3ba3a7765fb2dec731f3722c4cb6ee5b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3ba3a7765fb2dec731f3722c4cb6ee5b">&#9670;&nbsp;</a></span>print_list() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void cpp20print::printing::detail::print_list </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const L &amp;&#160;</td>
          <td class="paramname"><em>list</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> &amp;&#160;</td>
          <td class="paramname"><em>options</em> = <code>{}</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Prints an unordered list. </p>
<p>(Will be truncated as [1, 2, 3, ...]). Individual elements will be printed as if directly passed to print. </p>

</div>
</div>
<a id="a9e9ae4f30c9bde484e0c197b90e39e46"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9e9ae4f30c9bde484e0c197b90e39e46">&#9670;&nbsp;</a></span>print_pair()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void cpp20print::printing::detail::print_pair </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const P &amp;&#160;</td>
          <td class="paramname"><em>pair</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structcpp20print_1_1printing_1_1PrintOptions.html">PrintOptions</a> &amp;&#160;</td>
          <td class="paramname"><em>options</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Prints a pair. </p>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="adc7f764bf8b8bbba1e7c57153ac51413"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adc7f764bf8b8bbba1e7c57153ac51413">&#9670;&nbsp;</a></span>PrintableListNoString</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">concept PrintableListNoString</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Initial value:</b><div class="fragment"><div class="line">= </div>
<div class="line">        concepts::PrintableList&lt;T&gt; &amp;&amp;</div>
<div class="line">        concepts::Printable&lt;T&gt; ==  <span class="keyword">false</span> &amp;&amp;</div>
<div class="line">        concepts::UnicodeString&lt;T&gt; == <span class="keyword">false</span></div>
</div><!-- fragment -->
<p>A list that is not a string or unicode string. </p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
